/*
    JSPWiki - a JSP-based WikiWiki clone.

    Copyright (C) 2001-2002 Janne Jalkanen (Janne.Jalkanen@iki.fi)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.ecyrd.jspwiki.tags;

import java.util.ArrayList;
import java.util.Collection;

import org.apache.log4j.Logger;

import com.ecyrd.jspwiki.WikiContext;
import com.ecyrd.jspwiki.WikiEngine;
import com.ecyrd.jspwiki.ui.Editor;
import com.ecyrd.jspwiki.ui.EditorManager;

/**
 *  Iterates through editors.
 *
 *  @author Chuck Smith
 *  @since 2.4.12
 */

public class EditorIteratorTag
    extends IteratorTag
{
    private static final long serialVersionUID = 0L;

    static    Logger    log = Logger.getLogger( EditorIteratorTag.class );

    public final int doStartTag()
    {
        m_wikiContext = WikiContext.findContext(pageContext);

        WikiEngine engine = m_wikiContext.getEngine();
        EditorManager mgr    = engine.getEditorManager();

        String[] editorList = mgr.getEditorList();

        Collection editors = new ArrayList();

        for ( int i = 0; i < editorList.length; i++ )
        {
            editors.add(new Editor(m_wikiContext, editorList[i]));
        }
        setList( editors );

        return super.doStartTag();
    }
}
